'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _recompose = require('recompose');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _shared = require('./shared');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var withTransitionStates = (0, _recompose.withHandlers)(function () {
  var _leaving = {};
  return {
    leaving: function leaving() {
      return function () {
        return _leaving;
      };
    },
    setLeaving: function setLeaving() {
      return function (key, child, index) {
        _leaving[key] = { child: child, index: index };
      };
    },
    setLeft: function setLeft(_ref) {
      var forceUpdate = _ref.forceUpdate;
      return function (key) {
        delete _leaving[key];
        forceUpdate();
      };
    }
  };
});

var diffChildren = function diffChildren(prev) {
  var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref2$duration = _ref2.duration,
      duration = _ref2$duration === undefined ? 500 : _ref2$duration,
      setLeaving = _ref2.setLeaving,
      setLeft = _ref2.setLeft,
      updates = _ref2.updates,
      children = _ref2.children;

  if (prev.updates === updates && prev.children === children) return false;

  var nextChildren = _react.Children.toArray(children).reduce(_shared.nextReducer, {});

  _react.Children.toArray(prev.children).forEach(function (child, i) {
    if (!nextChildren[child.key]) {
      setLeaving(child.key, child, i);
      setTimeout(function () {
        return setLeft(child.key);
      }, duration);
    } else {
      delete nextChildren[child.key];
    }
  });

  return true;
};

var statusClassNames = function statusClassNames(_ref3) {
  var As = _ref3.As,
      leaving = _ref3.leaving,
      _ref3$entering = _ref3.entering,
      entering = _ref3$entering === undefined ? 'entering' : _ref3$entering,
      _ref3$entering_revers = _ref3.entering_reverse,
      entering_reverse = _ref3$entering_revers === undefined ? 'entering_reverse' : _ref3$entering_revers,
      _ref3$exiting = _ref3.exiting,
      exiting = _ref3$exiting === undefined ? 'exiting' : _ref3$exiting,
      _ref3$exiting_reverse = _ref3.exiting_reverse,
      exiting_reverse = _ref3$exiting_reverse === undefined ? 'exiting_reverse' : _ref3$exiting_reverse,
      reverse = _ref3.reverse,
      children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ['As', 'leaving', 'entering', 'entering_reverse', 'exiting', 'exiting_reverse', 'reverse', 'children']);

  return _extends({}, props, {
    children: _react.Children.map(children, function (child) {
      return leaving().hasOwnProperty(child.key) ? (0, _react.cloneElement)(child, { className: (0, _classnames2.default)(child.props.className, reverse ? exiting_reverse : exiting) }) : (0, _react.cloneElement)(child, { className: (0, _classnames2.default)(child.props.className, reverse ? entering_reverse : entering) });
    })
  });
};

exports.default = (0, _recompose.compose)(_shared.triggerForceUpdates, withTransitionStates, (0, _recompose.withPropsOnChange)(diffChildren, _shared.zipLeaving), (0, _recompose.mapProps)(statusClassNames));